//+------------------------------------------------------------------+
//|                                                     Arrows_2.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, "
#property link      ""
//----------------------------------------------------------------------------------------------

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red



extern int WPR_Period =14;
double WPR_1,WPR_0;
double CrossUp[];
double CrossDown[];
datetime barTime=0; // global variable


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {

//---- indicators
SetIndexStyle(0, DRAW_ARROW, EMPTY);
SetIndexArrow(0, 233);
SetIndexBuffer(0, CrossUp);
SetIndexStyle(1, DRAW_ARROW, EMPTY);
SetIndexArrow(1, 234);
SetIndexBuffer(1, CrossDown);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Crossed20 (double value0, double value1)
   {
      int current_arrow=0;
      int last_arrow=0;
      if(value1>-20 && value0<-20)current_arrow = 2; //down arrow
      else current_arrow=0;
      if(current_arrow != last_arrow) //changed 
      {
            last_arrow = current_arrow;
            return (last_arrow);
      }
      else
      {
            return (0);
      }
   
   }   
  
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int Crossed80 (double value0, double value1)
   {
      int current_arrow=0;
      int last_arrow=0;
      if(value1<-80 && value0>-80)current_arrow = 1; //up arrow
      else current_arrow=0;
      if(current_arrow != last_arrow) //changed 
      {
            last_arrow = current_arrow;
            return (last_arrow);
      }
      else
      {
            return (0);
      }
     
   }   
   
//+------------------------------------------------------------------+  
   
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
int isCrossed20,isCrossed80;
WPR_0 =0 ;
WPR_1=0;
  //---- check for history and trading
if( barTime < Time[0] )
  {
    //ONLY get here IF *new bar*
    // we have a new bar opened
    barTime = Time[0]; // keep the new bar open time
    //now we do ALL new bar work...
int counted_bars = IndicatorCounted();
int i;
int limit;
if(counted_bars < 0) 
return(-1);
if(counted_bars > 0) 
counted_bars--;
limit = Bars - counted_bars;

for(i=0; i<=limit; i++)
{
WPR_0 = iWPR(NULL,0,WPR_Period,i);
WPR_1 = iWPR(NULL,0,WPR_Period,i+1);

  if(WPR_1>-20)
  {
    isCrossed20 = Crossed20 (WPR_0,WPR_1);
    if(isCrossed20==2)CrossDown[i]=High[i]+0.0020;  
  }
  if(WPR_1<-80)
  {
    isCrossed80  = Crossed80 (WPR_0,WPR_1);
    if(isCrossed80==1)CrossUp[i]=Low[i]-0.0020;  
  }     

}
}  
//----
   return(0);
  }
//+------------------------------------------------------------------+